#ifndef bqtBindingQbHH
#define bqtBindingQbHH

#include <string>

void SetDefVarType(char begin, char end, char type);
void SetMetaDynamic();
void SetMetaStatic();

struct IdentifierLookupResult
{
    bool IsVar;
    bool IsTypedVar;
    bool IsType;
    bool IsSub;
    bool IsFunc;
    bool IsConst;
    bool IsLabel;
};
IdentifierLookupResult IdentifierLookup(const std::string& varname);

inline bool IsDefinedAsNonSub(const std::string& varname)
{
    IdentifierLookupResult r = IdentifierLookup(varname);
    return r.IsVar | r.IsTypedVar | r.IsConst | r.IsFunc;
}
inline bool IsDefinedAsNonFunc(const std::string& varname)
{
    IdentifierLookupResult r = IdentifierLookup(varname);
    return r.IsVar | r.IsTypedVar | r.IsConst | r.IsSub;
}
inline bool IsDefinedAsSubFuncVarConst(const std::string& varname)
{
    IdentifierLookupResult r = IdentifierLookup(varname);
    return r.IsVar | r.IsTypedVar | r.IsConst | r.IsSub | r.IsFunc;
}
inline bool IsDefinedAsRedimmable(const std::string& varname)
{
    IdentifierLookupResult r = IdentifierLookup(varname);
    return r.IsVar | r.IsTypedVar;
}

inline bool IsType(const std::string& varname) { return IdentifierLookup(varname).IsType; }
inline bool IsConst(const std::string& varname) { return IdentifierLookup(varname).IsConst; }
inline bool IsVar(const std::string& varname)
    { IdentifierLookupResult r = IdentifierLookup(varname);
      return r.IsVar|r.IsTypedVar; }
inline bool IsSub(const std::string& varname) { return IdentifierLookup(varname).IsSub; }
inline bool IsFunc(const std::string& varname) { return IdentifierLookup(varname).IsFunc; }
inline bool IsSubFunc(const std::string& varname)
    { IdentifierLookupResult r = IdentifierLookup(varname);
      return r.IsSub|r.IsFunc; }
inline bool IsLabel(const std::string& varname) { return IdentifierLookup(varname).IsLabel; }
#endif
