#include <string>
#include <vector>

#include "autoptr"

#include "qb.tab.h"

#include "expr.hh"

class stmt: public ptrable
{
public:
    stmt();
    virtual ~stmt();
};
typedef autoptr<stmt> stmtp;

class statements: public vector<stmtp>
{
public:
    statements() { }
	statements(stmt *b)    { push_back(b); }
};


class stmt_if: public stmt
{
	exprp cond;
	stmtp positive; // may be null
	stmtp negative; // may be null
public:
};
class stmt_do: public stmt
{
	// Only one of these is used:
	exprp dowhilecond;
	exprp dountilcond;
	exprp loopwhilecond;
	exprp loopuntilcond;
	
	exprp content;
public:
};
// while-wend is runtime changed to dowhile-loop.
// It's not needed.
class stmt_for: public stmt
{
	autoptr<expr_var> var;
	exprp startvalue;
	exprp endvalue;
	exprp step;      // or NULL
	
	stmtp contnet;	
};
class stmt_select: public stmt
{
	exprp condition;
	
	vector<pair<casevalues, stmtp> > cases;
};


class stmt_let: public stmt
{
	autoptr<expr_var> target;
	exprp value;
public:
};
